package de.ctdo.crashtest;

public class Statemachine {
    private final char BLUE_BUTTON = 'd';
    private final char LIGHT_BARRIER = 'k';
    private final char TABLE_ONE = 'c';
    private final char TABLE_TWO = 'v';
    private final char TABLE_THREE = 'b';

    public enum state {
        IDLE,
        ENTERED_ROOM,
        TABLE_GAME_ONE,
        TABLE_GAME_TWO,
        TABLE_GAME_THREE,
        TABLE_GAME_FOUR,
        TABLE_GAME_FIVE,
        TABLE_GAME_SIX,
        TABLE_GAME_SEVEN,
        FINISH,
    }

    private state currentState = state.IDLE;


    public state getCurrentState() {
        return currentState;
    }

    public void handleInput(char input) {

        state newState = getNewState(input);

        System.out.println("newState = " + newState);

        currentState = newState;
    }

    private state getNewState(char input) {
        state retVal = currentState;
        
        switch (currentState) {
            case IDLE:
                if(input == LIGHT_BARRIER) {
                    retVal = state.ENTERED_ROOM;
                }
                break;
            case ENTERED_ROOM:
                if(input == TABLE_ONE) {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_ONE:
                if(input == TABLE_TWO) {
                    retVal = state.TABLE_GAME_TWO;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_TWO:
                if(input == TABLE_THREE) {
                    retVal = state.TABLE_GAME_THREE;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_THREE:
                if(input == TABLE_TWO) {
                    retVal = state.TABLE_GAME_FOUR;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_FOUR:
                if(input == TABLE_THREE) {
                    retVal = state.TABLE_GAME_FIVE;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_FIVE:
                if(input == TABLE_ONE) {
                    retVal = state.TABLE_GAME_SIX;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_SIX:
                if(input == TABLE_THREE) {
                    retVal = state.TABLE_GAME_SEVEN;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;
            case TABLE_GAME_SEVEN:
                if(input == BLUE_BUTTON) {
                    retVal = state.FINISH;
                } else {
                    retVal = state.TABLE_GAME_ONE;
                }
                break;


        }


        return retVal;
    }
}
